import 'package:cramr_ui_lib/model/conjugation.dart';
import 'package:flutter_test/flutter_test.dart';

void main() {
  group('general tests for the conjugation', () {
    test('constructor and getters', () {
      const String mode = 'mode';
      const String tense = 'tense';
      const List<String> conjugation = [
        'first',
        'second',
        'third',
        'fourth',
        'fifth',
        'sixth'
      ];
      Conjugation model = Conjugation(mode, tense, conjugation);
      expect(mode, model.mode);
      expect(tense, model.tense);
      for (var element in conjugation) {
        expect(true, model.conjugation.contains(element));
      }
      for (int i = 0; i < conjugation.length; i++) {
        expect(conjugation[i], model.conjugation[i]);
      }
    });
    test('test the identifier', () {
      const String mode = 'mode';
      const String tense = 'tense';
      const List<String> conjugation = [
        'first',
        'second',
        'third',
        'fourth',
        'fifth',
        'sixth'
      ];
      Conjugation model = Conjugation(mode, tense, conjugation);
      expect(mode, model.mode);
      expect(tense, model.tense);
      expect('${mode}_$tense', model.getIdentifier());
    });
  });
}
