import 'package:cramr_ui_lib/model/verb_test_model.dart';
import 'package:cramr_ui_lib/routes/verb_studymode_selection_route.dart';
import 'package:cramr_ui_lib/settings/client_context.dart';
import 'package:cramr_ui_lib/settings/notification_service.dart';
import 'package:cramr_ui_lib/settings/settings_controller.dart';
import 'package:cramr_ui_lib/settings/settings_service.dart';
import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:provider/provider.dart';
import 'package:shared_preferences/shared_preferences.dart';

final List<String> _randomIndicative = [
  'exp1',
  'exp2',
  'exp3',
  'exp4',
  'exp5',
  'exp6',
];

final List<String> _randomPronouns = [
  'pron1',
  'pron2',
  'pron3',
  'pron4',
  'pron5'
      'pron6',
];

const String _mode = 'mode';
const String _tense = 'tense';

void main() {
  testWidgets('Test the selection of the study mode',
      (WidgetTester tester) async {
    SharedPreferences.setMockInitialValues(<String, Object>{'counter': 1});
    SharedPreferences prefs = await SharedPreferences.getInstance();
    await tester.pumpWidget(ChangeNotifierProvider(
      create: (BuildContext context) {
        var model = VerbTestModel();
        model.initialise(_randomIndicative, _randomPronouns, 'infinitive', 'fr',
            'translation', _mode, _tense);
        return model;
      },
      child: MaterialApp(
        home: VerbStudymodeSelectionRoute(SettingsController(
            SettingsService(prefs),
            ThemeMode.dark,
            prefs,
            NotificationService(),
            ClientContext(ClientApp.verbomatiqueSecondaire))),
      ),
    ));
    Finder coverModeButtonFinder = find.byKey(const Key('buttonCoverMode'));
    expect(coverModeButtonFinder, findsOneWidget);
    Finder flashModeButtonFinder = find.byKey(const Key('buttonFlashCardMode'));
    expect(flashModeButtonFinder, findsOneWidget);
    Finder writeModeButtonFinder = find.byKey(const Key('buttonWriteMode'));
    expect(writeModeButtonFinder, findsOneWidget);
  });
}
