import 'package:cramr_ui_lib/util/pronoun_decorator.dart';
import 'package:flutter_test/flutter_test.dart';

void main() {
  group('pronoun decorator tests in all permutations', () {
    test('french with apostrophe', () {
      expect('j\'', PronounDecorator.decoratedPronoun('fr', 'je', 'ai'));
    });

    test('french without apostrophe', () {
      expect('tu', PronounDecorator.decoratedPronoun('fr', 'tu', 'as'));
      expect('je', PronounDecorator.decoratedPronoun('fr', 'je', 'suis'));
    });

    test('non-french without apostrophe where french requires one', () {
      expect('je', PronounDecorator.decoratedPronoun('en', 'je', 'ai'));
    });

    test('non-french without apostrophe where french does not require one', () {
      expect('tu', PronounDecorator.decoratedPronoun('en', 'tu', 'as'));
    });
  });
}
